##############################################################################################
#
# JoinPartie.tcl
#
#    Ce fichier contient l'ensemble des operations lies a la saisie et acceptation
#    des parametres de creation d'une nouvelle partie. 
#
##############################################################################################

namespace eval JoinPartie {
    global Glob
    variable this

    ##########################################################################################
    # JoinPartie::Protocole
    #
    #    Cette fonction realise les operations a effectuer en fonction des messages recus
    #    du serveur. Ces operations sont celles liees au protocole.
    #     
    ##########################################################################################
    proc Protocole {opt {args {}}} { Debug "[namespace current]::Protocole"
	global Glob
	variable this
	
	set args [lindex $args 0]
	switch [lindex $opt 0] {
	    "BAD" { 
		;# On recoit un BAD si au moins un des parametres de creation d'une nouvelle 
		;# partie est incorrect
		;# Dans ce cas on affiche un message et l'utilisateur doit recommencer la 
		;# saisie

		;#    - si on est refuse a l'integration d'une partie (dans ce cas on doit etre
		;#      dans la phase join)
		;# On doit alors afficher le message d'erreur et effectuer certaines operations
		;# specifiques a la phase dans laquelle on se trouve.

		grab release $this(top)
		update
		Message "$Glob(prg) - Erreur" "Votre acces a la partie est refuse !" error
		destroy $this(top)
		ListeParties::Active
		set Glob(phase) ListeParties
	    }
	    "OK"  {
		;# Si on recoit un OK c'est que l' on est accepte dans la partie
		;# On doit alors afficher la grille de jeu et passer dans la phase de jeu
		grab release $this(top)
		update
		destroy $this(top)
		ListeParties::Desactive
		set Glob(phase) JouePartie
		JouePartie::Draw
	    }
	}
    }
    
    ##########################################################################################
    # JoinPartie::Draw
    #
    #    Cette fonction realise l'affichage de la fenetre de saisie des parametres pour la
    #    creation d'une nouvelle partie.
    #
    ##########################################################################################
    proc Draw {} { Debug "[namespace current]::Draw"
	global Glob verrou
	variable this
	
	set w .nouv_partie
	set this(top) $w
	catch {destroy $w}
	toplevel $w
	wm title $w "$Glob(prg) - Attente Acceptation"
	wm iconname $w $Glob(prg)
	wm maxsize $w [winfo screenwidth .] [winfo screenheight .]
	wm resizable $w 0 0

	label $w.lab -text "On attend l'acceptation (ou le refus)\npar les autres joueurs" \
		       -font {Helvetica 16 bold}
	pack $w.lab -fill both -expand yes

	centerDialog $this(top) $ListeParties::this(top)
	grab $this(top)
	focus $this(top)
    }
    
}
