# 
# Un ensemble de fonctions Tcl utiles
#
# Pierre Vassellerie - (c) Juin 1995
# Pierre.Vassellerie@obspm.fr
#

# -----------------------------------------------------------------------
proc watch_cursor {} {
	set busy ""
	foreach w [winfo children .] {
			lappend busy [list $w [lindex [$w config -cursor] 4]]
	}
	foreach w $busy {catch {[lindex $w 0] config -cursor watch}}
	update
}

# -----------------------------------------------------------------------
proc normal_cursor {} {
	set busy ""
	foreach w [winfo children .] {
			lappend notbusy [list $w [lindex [$w config -cursor] 4]]
	}
	foreach w $notbusy {catch {[lindex $w 0] config -cursor hand2}}
	update idletasks
}

# -----------------------------------------------------------------------
proc Max { a b } {
  if { $a >= $b } { return $a
    } else { return $b }
}
# -----------------------------------------------------------------------
# Procedure de comparaison pour tri d'apres un index de listes
# -----------------------------------------------------------------------
proc tri_liste {opt index a b} {

	switch $opt {
		"index" {
			set a1 [lindex $a $index]
			set b1 [lindex $b $index]
			
#			puts "$a:$a1 $b:$b1"
			return [string compare $a1 $b1]
		}
		"nb" {
			set a1 [llength [lindex $a $index]]
			set b1 [llength [lindex $b $index]]
			if { $a1 <  $b1 } { return -1 }
			if { $a1 == $b1 } { return 0 }
			if { $a1 >  $b1 } { return 1 }
		}
	}
}
# -----------------------------------------------------------------------
# Force une variable lors de la saisie a etre d'un certain type
# -----------------------------------------------------------------------
proc Force {opt nom index op} { global $nom ${nom}_int
	
#	 puts "Force"
#	 puts "   opt=$opt [string match Zone* $opt]"
#	 puts "   nom=$nom"
#	 puts "   index=$index"
#	 puts "   op=$op"
	
	if [string comp {} $index] {
		set old  ${nom}_int\($index)
	        set nom $nom\($index)
        } else { 
                set old ${nom}_int 
        }

	switch -glob $opt {
		"Int" 	 { set exp {^[-+]?[0-9]*$} }
		"Float"  { set exp {^[-+]?[0-9]*\.?[0-9]*([0-9]\.?e[-+]?[0-9]*)?$} }
		"String" { set exp {^[A-Za-z0-9 ]*$} }
		"Hexa"   { set exp {^(0[xX])?[0-9a-fA-F]*$} }
                "AlphaNum" { set exp {^[0-9a-zA-Z_!?\#]*$} }
         }

	if ![regexp $exp [set $nom]] {
	   set $nom [set $old]
	   bell; return
	}
	set $old [set $nom]
}

proc Zone {opt tab index op} { global $tab ${tab}_int
	
# 	puts "Zone"
# 	puts "   opt=$opt"
# 	puts "   tab=$tab"
# 	puts "   index=$index"
# 	puts "   op=$op"
# 	puts "   tab_int=${tab}_int"
# 	puts "   tab_int=$Glob($index)"

        set idx [string first - $opt]
        set min [string range $opt 0 [expr $idx -1]]
	set max [string range $opt [expr $idx +1] end]
# 	puts "idx=$idx min=$min max=$max"

	if [string comp {} $index] {
		set old  ${tab}_int\($index)
	        set nom $tab\($index)
        } else { 
                set old ${tab}_int 
        }
	set val [set $nom]
# puts "min=$min val=$val max=$max"

if {$val!=5} {bell; set $nom [set $old]; return}

	# Verification que ce sont des chiffres qui sont saisis
#if ![regexp [0-9]? $val] { set $nom [set $old] ; bell; return }
# Verification que ce n'est pas un 0 qui est saisie en debut si la zone
# commence apres 0 (pb des nombres en octal comme 013)
if {$min!=0 && $val==0} { bell; set $nom [set $old] ; return }
# Verification que la valeur saise est bien dans la zone
#if {$val<$min || $val>$max}  { set $nom [set $old] ; bell; return }

	set $old [set $nom]
}


# -----------------------------------------------------------------------
proc centerDialog {dialog relativeTo} {
	wm withdraw $dialog
	update
    set x [expr int([winfo rootx $relativeTo] + \
           ([winfo width $relativeTo]-[winfo reqwidth $dialog])/2)]
    if {$x<1} {set x 1}
    set y [expr int([winfo rooty $relativeTo] + \
           ([winfo height $relativeTo]-[winfo reqheight $dialog])/2)]
    if {$y<1} {set y 1}
    wm geometry $dialog +$x+$y
    wm deiconify $dialog
}
# -----------------------------------------------------------------------
proc CenterScreen {dialog} {
	wm withdraw $dialog
	update
    set x [expr [winfo screenwidth .]/2 - [winfo reqwidth $dialog]/2]
    if {$x<1} {set x 1}
    set y [expr [winfo screenheight .]/2 - [winfo reqheight $dialog]/2]
    if {$y<1} {set y 1}
    wm geometry $dialog +$x+$y
    wm deiconify $dialog
}

