/* 
 * titbetAppInit.c --
 *
 * La majeure partie de ce code est celui de tkAppInit.c contenu dans
 * le repertoire lib de tk
 *
 */

#include "tk.h"

extern int matherr();
int *tclDummyMathPtr = (int *) matherr;

#ifdef TK_TEST
EXTERN int		Tktest_Init _ANSI_ARGS_((Tcl_Interp *interp));
#endif /* TK_TEST */

int
main(argc, argv)
    int argc;			/* Number of command-line arguments. */
    char **argv;		/* Values of command-line arguments. */
{
    Tk_Main(argc, argv, Tcl_AppInit);
    return 0;			/* Needed only to prevent compiler warning. */
}


int
Tcl_AppInit(interp)
    Tcl_Interp *interp;		/* Interpreter for application. */
{
    if (Tcl_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
    if (Tk_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }

#ifdef TK_TEST
    if (Tktest_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
    Tcl_StaticPackage(interp, "Tktest", Tktest_Init,
            (Tcl_PackageInitProc *) NULL);
#endif /* TK_TEST */



    /******************************************************************/
    /* Ceci suffit a avoir de quoi fabriquer l'interpreteur avec les  */
    /* nouvelles commandes contenu dans client.c                      */
    /* Lors du load de la librairie par TCL la fonction Titbet_Init   */
    /* est immediatement appelee, alors qu'avec l'interpreteur on     */
    /* doit specifier cet appel.                                      */
    /******************************************************************/
    if (Titbet_Init(interp) == TCL_ERROR) {
        return TCL_ERROR;
    }


    /* On retourne dans du code contenu par defaut dans Tk_AppInit */

    Tcl_SetVar(interp, "tcl_rcFileName", "~/.wishrc", TCL_GLOBAL_ONLY);
    return TCL_OK;
}
