/* -*-linux-c-*-
** $Id: libmorpion.h,v 1.3 1998/04/24 15:25:45 enlight Exp $
** $Log: libmorpion.h,v $
** Revision 1.3  1998/04/24 15:25:45  enlight
** Ajout des fonctions morpion_existPlayer, morpion_existGame,
**  morpion_noticeToAllPlayers.
**
** Revision 1.2  1998/04/23 03:27:53  enlight
** Ajout du type enum MORPION_OK
**
** Revision 1.1  1998/04/22 19:07:15  enlight
** Initial revision
**
*/

#ifndef _LIBMORPION_H_
#define _LIBMORPION_H_

#define BROADCAST_GAME       1 /*0001*/
#define BROADCAST_ALLGAME    2 /*0010*/
#define BROADCAST_ALLPLAYERS 4 /*0100*/
#define BROADCAST_PLAYER     8 /*1000*/

#define IDPLAYEROUT          0 /* IdPlayer du jour qui quitte une 
                                  partie. */

#define MORPION              0 /* indice du tableau partie */
#define PUISSANCE4           1 /* indice du tableau partie */

typedef enum {
	MORPION_OK,
	MORPION_PLAYERINGAME,
	MORPION_ERROR,
	MORPION_PLAYERNOEXIST,
	MORPION_GAMENOEXIST,
	MORPION_GAMEWIN,
	MORPION_GRIDFULL,
	MORPION_HITKO,
	MORPION_HITOUTGRID,
	MORPION_GAMEEXIST,
	MORPION_GAMEFULL,
	MORPION_NOICON,
	MORPION_ACCEPTED,
	MORPION_UNKNOWGAME,
	MORPION_MAXHIT,
	MORPION_VOTENOEXIST
} valMorpion;

valMorpion morpion_init(Sockets *s);
valMorpion morpion_deleteGame(long idGame ,Games *games);
valMorpion morpion_newGame(int width, int height, char *gameName,
	   long *idGame, int type, Games *games);
valMorpion morpion_hit(int *xCoord, int *yCoord, int numSock, long idGame, 
		Games *games);
valMorpion morpion_addPlayer(int numSock, long idGame, Games *games);
valMorpion morpion_deletePlayerFromGame(ListGameItem **nextGame, 
      int numSock, long idGame, Games *games);
valMorpion morpion_deletePlayer(int numSock, Games *games);
int morpion_nextPlayer(long idGame, Games *games);
int morpion_playerInGame(long idGame, Games *games);
char* morpion_infoPlayer(ListPlayerSockItem *listPlayerSockItem, Games *games);
char* morpion_infoGame(long idGame, Games *games);
char* morpion_infoGames(Games *games);
char* morpion_grid(long idGame, Games *games);
valMorpion morpion_noticeToAllPlayers(int numSock, long idGame, char dest,
           char *message, Games *games);
int morpion_existPlayer(char *playerName, Games *games);
valMorpion morpion_existGame(char *gameName, Games *games);
ListGameItem* morpion_existGameNum(long idGame, Games *games);
valMorpion morpion_updateGrid(int playerId, Game *game);
valMorpion morpion_getPlayerId(int *idPlayer, int numSock, long idGame,
           Games *games);
valMorpion morpion_getNumSock(int playerId, int *numSock, long idGame,
           Games *games);
valMorpion morpion_statOfGame(int xCoord, int yCoord, int playerId,
		       Game *game);
valMorpion morpion_askVote(int numSock, int idGame, Games *games);
valMorpion morpion_removeVote(int numPlayerToAccept, int numGameToVoteOn,
			Games *games);
valMorpion morpion_vote(int numPlayerToAccept, int numGameToVoteOn,
			Games *games);

void morpion_playerReInit(int userNum, Sockets *sockets);


#endif
