#!/bin/sh

# Explication des options utilisees:
# -t Pour indiquer que le fichier des parametres doit prendre
#    en compte que les mots clef sont dans une structure.
# -l Optimization to indicate that the code can add some code
#    to check first keywork against their length.
# -o Another optimization from gperf to place most frequently
#    used words first.
# -r Initialize with random values before generating the table
# -C Contents of all generated lookup tables constant
# -c Generates C code that uses the strncmp function to 
#    perform string comparisons.
# -g Adds 'inline' for GNU compilers
# -p returns the structure instead of a boolean

OPTIONS=-tCcgplor
GPERF=`which gperf`
[ -f $GPERF ] &&  gperf $OPTIONS keyfile.words > libprotocol.c
