/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -tCcgplor keyfile.words  */ /* -*- linux-c -*-
** $Id: keyfile.words,v 1.3 1998/04/23 03:19:21 enlight Exp enlight $
** $Log: keyfile.words,v $
** Revision 1.3  1998/04/23 03:19:21  enlight
** Ajout et implementation des fonctions NICK, IMG, JOIN
**
** Revision 1.2  1998/04/23 00:04:37  enlight
** Modification du protocol pour NICK.
** Netoyage du decoupage des args avec la fonction split2Args
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "servMorp.h"
#include "libsecur.h"
#include "libconnex.h"
#include "libmorpion.h"
#include "libprotocol.h"

INLINE int proto_evalMessage(SockEvent *);

void proto_DEBUG(SockEvent *, char *);
void proto_HIT(SockEvent *, char *);
void proto_NICK(SockEvent *, char *);
void proto_JOIN(SockEvent *, char *);
void proto_NEW(SockEvent *, char *);
void proto_YES(SockEvent *, char *);
void proto_NO(SockEvent *, char *);
void proto_QUIT(SockEvent *, char *);

struct commands { char *name; void (*func)(SockEvent *ev, char *args); }; ;

#define TOTAL_KEYWORDS 8
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 5
#define MIN_HASH_VALUE 6
#define MAX_HASH_VALUE 13
/* maximum key range = 8, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
hash (str, len)
     register char *str;
     register int unsigned len;
{
  static const unsigned char asso_values[] =
    {
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14,  3, 14,
     14,  0,  5, 14,  5,  3, 14, 14,  3,  4,
     14,  0, 14,  0,  3, 14, 14,  7, 14,  3,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     14, 14, 14, 14, 14, 14, 14, 14,
    };
  return len + asso_values[str[len - 1]] + asso_values[str[0]];
}

#ifdef __GNUC__
inline
#endif
const struct commands *
in_word_set (str, len)
     register char *str;
     register unsigned int len;
{

  static const unsigned char lengthtable[] =
    {
      0,  0,  0,  0,  0,  0,  3,  4,  5,  2,  4,  3,  4,  3,
    
    };
  static const struct commands wordlist[] =
    {
      {"",}, {"",}, {"",}, {"",}, {"",}, {"",}, 
      {"YES",     proto_YES},
      {"QUIT",    proto_QUIT},
      {"DEBUG", 	proto_DEBUG},
      {"NO",      proto_NO},
      {"NICK",    proto_NICK},
      {"HIT",     proto_HIT},
      {"JOIN",    proto_JOIN},
      {"NEW",     proto_NEW},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (len == lengthtable[key]
              && *s == *str && !strncmp (str + 1, s + 1, len - 1))
            return &wordlist[key];
        }
    }
  return 0;
}



/* ************************************************************************
** FUNCTION - isNumber
**   .Usage.
**      Small function to test if a string is a number or not
**   .Input.
**      A NULL terminated string
**   .Return. 
**      A boolean value telling if the string is a number
** ***********************************************************************/
INLINE
int isNumber(char *str)
{
    if (str == NULL)
        return 0;

    while (*str != '\0'){
        if (!isdigit(*str))
            return 0;
        str++;
    }
    return 1;
}

/* ************************************************************************
** FUNCTION - splitArgs
**   .Usage.
**      This function splits a string around a token and returns
**      the second arg. The first arg is returned in the function
**      and is automatically adjusted.
**   .Input.
**      A NULL terminated string, and a token
**   .Return. 
**      Two NULL terminated strings
** ***********************************************************************/
INLINE
char * split2Args(char *strLeftIn, const char token)
{
    char *strRight = strLeftIn, *ptrTmp;
    int balanceCount = 0, foundToken = 0;

    /* 
    ** Nettoyage de la chaine en retirant les espaces apres la chaine 
    ** On part de la fin...
    */
    ptrTmp = strLeftIn + strlen(strLeftIn) - 1;
    while (*ptrTmp == ' ')
        ptrTmp--;
    *(ptrTmp + 1) = '\0';
 
    while(*strRight != '\0'){
        if ((*strRight == '\"')||(*strRight == '{')||(*strRight == '}')){
            balanceCount ^= 1;

            ptrTmp = strRight;
            while(*(ptrTmp + 1) != '\0'){
                *ptrTmp = *(ptrTmp + 1);
                ptrTmp++;
            }
            *(ptrTmp) = '\0';
            strRight--;

        } else if ((!balanceCount) && (*strRight == token)){
            /* Are we in some sort of quotes ? */
            *(strRight++) = '\0';
	    foundToken = 1;
            break;
        }
        strRight++;
    }
    
#if 0
    /* If there is no need to scan for quotes use this function */
    strRight = strchr(strLeftIn, token);
    if (strRight != NULL)
        *(strRight++) = '\0';
#endif

    if (foundToken)
         return strRight;

    return NULL;
}

/* ************************************************************************
** FUNCTION - eval_message
**   .Usage.
**      This function evaluates the keyword passed in
**      parameter and pass the args to the good function.
**   .Input.
**      Nothing
**   .Return.
**      Error code
** ***********************************************************************/
INLINE 
int proto_evalMessage(SockEvent *ev)
{
    char *args = NULL;
    const struct commands *msgTable;
    int strln;

    strln = strlen(ev->content);
    if (ev->content[strln-1] == '
'){
    	NOTICE("Telnet detected", ".");
	ev->content[strln-1] = '\0';
    }


    /*
    ** Here, we split the revceived message in two parts:
    ** The "header", or command, and the rest of the line
    ** which will be called args. 
    */
    if ((args = split2Args(ev->content, ' ')) == NULL){
        NOTICE("Wrong data format detected [%s] !\n", ev->content);        
        socket_print(ev->fd, "BAD Command unrecognized\n");
        return -1;
    }

#if 0
    /*
    ** !!! SECURITY !!! Test that there is data after the space,
    ** otherwise, the program will trash.
    ** In the current implementation, there will be ALWAYS something
    ** because of the '\n'...
    */
    if (((void *)args - (void *)&(ev->content)) >= ev->contentLen){
        NOTICE("Wrong data format detected !\n", ".");
        socket_print(ev->fd, "BAD Command unrecognized\n");
        return -1;
    }
#endif

    msgTable = in_word_set(ev->content, strlen(ev->content));
    if (msgTable == NULL){
        NOTICE("Command received was not recognized: [%s]", ev->content);
        socket_print(ev->fd, "BAD Command unrecognized\n");
        return -1;
    }

    /* 
    ** The magic call, now 
    */
    msgTable->func(ev, args); 

    return 0;
}

/* ************************************************************************
** FUNCTION - proto_DEBUG
**   .Usage.
**      This function is used to debug the server protocol and see if it
**      works correctly.
**   .Input.
**      Depends on the parameters used. Currently, only the 'REFLECT'
**      parameter is working. It return the sent string.
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_DEBUG(SockEvent *ev, char *args)
{
    if (!strncmp(args, "REFLECT", strlen("REFLECT"))){
        socket_print(ev->fd, args + 8);
    } else if (!strncmp(args, "QUIT_TUX", strlen("QUIT_TUX"))){
        kill(getpid(),  SIGTERM);
        exit(EXIT_FAILURE);
    }
}

/* ************************************************************************
** FUNCTION - proto_HIT
**   .Usage.
**      HIT <num partie> <x> <y>
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_HIT(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd, userId, xpos, ypos, numGame, retCode;
    char *sPosAll, *sPos, strToSend[50], *strToSendA, *listOfGames;

    if (s->games.players[user].playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }

    /* We get the num of the game in "args", and x and y in sPosAll */
    sPosAll = split2Args(args, ' ');
    if (sPosAll == NULL){
        socket_print(user, "BAD Wrongly formatted HIT command\n");
        return;
    }

    if (!isNumber(args)){
        socket_print(user, "BAD you need to enter the game number\n");
        return;
    }
    numGame =  atoi(args);
    morpion_getPlayerId(&userId, user, numGame, &(s->games));

    if (morpion_playerInGame(numGame, &(s->games)) != userId){
        socket_print(user, "BAD Not your turn to play\n");
        return;
    }


    /* We separate x and y from the string */
    sPos = split2Args(sPosAll, ' ');
    if (sPos == NULL){
        socket_print(user, "BAD Wrongly formatted HIT command\n");
        return;
    }

    if (!isNumber(sPosAll)){
        socket_print(user, "BAD You need to enter the X pos\n");
        return;
    }
    xpos = atoi(sPosAll);

    if (!isNumber(sPos)){
        socket_print(user, "BAD You need to enter the Y pos\n");
        return;
    }
    ypos = atoi(sPos);
    
    /* Let's see if the user gave valid coordinates */
    retCode = morpion_hit(&xpos, &ypos, user, numGame, &(s->games));
    switch(retCode){
    case MORPION_OK:
        /*
        ** We send the move to all the players in the game
        */
        sprintf(strToSend, "HIT %d %d %d %d\n", 
                           numGame, xpos, ypos, userId);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend,
                                   &(s->games));

        /* We send the Id of the next player to play */
        userId = morpion_nextPlayer(numGame, &(s->games));
        sprintf(strToSend, "PLAY %d %d\n", numGame, userId);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend,
                                   &(s->games));
        break;
    case MORPION_GAMENOEXIST:
        socket_print(user, "BAD Game does not exist\n");
        break;
    case MORPION_HITOUTGRID:
        socket_print(user, "BAD Chosen Cell is out of Grid\n");
        break;
    case MORPION_HITKO:
        socket_print(user, "BAD Chosen Cell is already used\n");
        break;
    case MORPION_GRIDFULL:
        morpion_getPlayerId(&userId, user, numGame, &(s->games));
        /*
        ** We send the move to all the players in the game
        */
        sprintf(strToSend, "HIT %d %d %d %d\n", 
                           numGame, xpos, ypos, userId);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend,
                                   &(s->games));

        /* Notify the end of the game */
        sprintf(strToSend, "END %d\n", numGame);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend, &(s->games));

        morpion_deleteGame(numGame ,&(s->games));

        /* We now send the updated list of games */
        listOfGames = morpion_infoGames(&(s->games));        
        strToSendA = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                                                   15));
        sprintf(strToSendA, "GAMES %s\n", listOfGames);        
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_ALLPLAYERS|BROADCAST_PLAYER,
                                   strToSendA,
                                   &(s->games));        
        free(listOfGames);
        free(strToSendA);
        
        NOTICE("Match nul pourla partie %d", numGame);

        break;
    case MORPION_GAMEWIN:
        morpion_getPlayerId(&userId, user, numGame, &(s->games));
        /*
        ** We send the move to all the players in the game
        */
        sprintf(strToSend, "HIT %d %d %d %d\n", 
                           numGame, xpos, ypos, userId);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend,
                                   &(s->games));

        sprintf(strToSend, "WIN %d %d\n", numGame, userId);
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend, &(s->games));
        morpion_deleteGame(numGame ,&(s->games));

        /* We now send the updated list of games */
        listOfGames = morpion_infoGames(&(s->games));        
        strToSendA = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                                                   15));
        sprintf(strToSendA, "GAMES %s\n", listOfGames);        
        morpion_noticeToAllPlayers(user, numGame, 
                                   BROADCAST_ALLPLAYERS|BROADCAST_PLAYER,
                                   strToSendA,
                                   &(s->games));        
        free(listOfGames);
        free(strToSendA);
        
        NOTICE("Joueur %d gagne la partie %d", user , numGame);


        break;
    default:
        NOTICE("ret(%d)=morpion_hit. user=%d", retCode, user);
    }
}

/* ************************************************************************
** FUNCTION - proto_NICK
**   .Usage.
**      NICK <nom_joueur>
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_NICK(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd;
    char *args2, *listOfGames, *strToSend;

    /* 
    ** We retrieve the active user and verify that the user hasn't 
    ** already registered by looking at the first car of its supposed
    ** name. If it is '\0', that means he's new. 
    */
    if (s->games.players[user].playerName[0] == '\0'){
        if (morpion_existPlayer(args, &(s->games)) != -1){
            socket_print(user, "BAD Nick Already Registered\n");
            return;
        }

        /* 
        ** Ok, he's new , let's clean that string
        ** No need to test the length of the string, because, there
        ** MUST to be a parameter.
        */
        secur_cleanString(args);
        strncpy(s->games.players[user].playerName, args, MAXPLAYERNAME);
        socket_print(user, "OK User Registered\n");

        listOfGames = morpion_infoGames(&(s->games));        
        strToSend = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                                                   15));
        sprintf(strToSend, "GAMES %s\n", listOfGames);        
        socket_print(user, strToSend);
        free(listOfGames);
        free(strToSend);

        NOTICE("New user (%d) is registering as %s", user, args, args2);
    } else
        socket_print(user, "BAD Already Registered user\n");
}

/* ************************************************************************
** FUNCTION - proto_YES
**   .Usage.
**      YES <num partie> <num_joueur>
**      This keyword is sent when the users are voting for the admission
**      of another user.
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_YES(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd, numPlayerToAccept, numPartie, retCode, userId;
    char *sNamePlayer, *strToSend, *gridToSend, *listOfGames;

    if (s->games.players[user].playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }

    /* We get the num of the game in "args", and the name in sPos */
    sNamePlayer = split2Args(args, ' ');
    if (sNamePlayer == NULL){
        socket_print(user, "BAD Wrongly formatted YES command\n");
        return;
    }

    /* Testing the presence of the game */
    if (!isNumber(args)){
        socket_print(user, "BAD You have to enter the game number\n");
        return;
    }
    numPartie = atoi(args);
    if (morpion_existGameNum(numPartie, &(s->games)) == NULL){
        socket_print(user, "BAD Wrongly formatted YES (game nb) command\n");
        return;
    }

    NOTICE("Joueur=%s\n", sNamePlayer);
    numPlayerToAccept = morpion_existPlayer(sNamePlayer, &(s->games));
    if (numPlayerToAccept == -1){
        socket_print(user, "BAD Wrongly formatted YES (player nb) command\n");
        return;
    }

#if 0
    /* Let's see if he's trying to cheat by voting again */
    if (morpion_hasAlreadyVotedforGame(user, numPartie, numPlayerToAccept)){
        socket_print(user, "BAD You have already voted for this game\n");
        return;
    }
#endif

    NOTICE("User %d has voted yes for the player %d", user, numPlayerToAccept);

    if (morpion_vote(numPlayerToAccept, numPartie,
                     &(s->games)) == MORPION_ACCEPTED){
        retCode = morpion_addPlayer(numPlayerToAccept, numPartie, &(s->games));
        PASSERT(retCode == MORPION_OK, 
                "Error in morpion_addPlayer(%d)", retCode);

        socket_print(numPlayerToAccept, "OK\n");

        listOfGames = morpion_infoGames(&(s->games));        
        strToSend = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                                                   15));
        sprintf(strToSend, "GAMES %s\n", listOfGames);
        morpion_noticeToAllPlayers(numPlayerToAccept, numPartie, 
                                   BROADCAST_GAME|BROADCAST_PLAYER,
                                   strToSend, &(s->games));
        free(strToSend);
        
        gridToSend = morpion_grid(numPartie, &(s->games));
        strToSend = (char *)malloc(sizeof(char) * (strlen(gridToSend) + 10));
        sprintf(strToSend, "GRID %s\n", gridToSend);
        socket_print(numPlayerToAccept, strToSend);
        free(strToSend);
        
        /* We send the Id of the next player to play */
        strToSend = (char *)malloc(sizeof(char) * 50);
        userId = morpion_playerInGame(numPartie, &(s->games));
        sprintf(strToSend, "PLAY %d %d\n", numPartie, userId);
        NOTICE("SEND : %s", strToSend);
        socket_print(numPlayerToAccept, strToSend);
        
        free(listOfGames);
        free(strToSend);
        free(gridToSend);
        
        /* We now remove the voting system from the list */
        morpion_removeVote(numPlayerToAccept, numPartie, &(s->games));
        return;
    }
}

/* ************************************************************************
** FUNCTION - proto_NO
**   .Usage.
**      YES <num partie> <nom_joueur>
**      This keyword is sent when the users are voting for the admission
**      of another user.
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_NO(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd, numPlayerToAccept, numPartie;
    char *sNamePlayer, *strToSend;

    if (s->games.players[user].playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }

    /* We get the num of the game in "args", and x and y in sPos */
    sNamePlayer = split2Args(args, ' ');
    if (sNamePlayer == NULL){
        socket_print(user, "BAD Wrongly formatted NO command\n");
        return;
    }

    /* Testing the presence of the game */
    if (!isNumber(args)){
        socket_print(user, "BAD You need to enter the game number\n");
        return;
    }
    numPartie = atoi(args);
    if (morpion_existGameNum(numPartie, &(s->games)) == NULL){
        socket_print(user, "BAD Wrongly formatted NO (game nb) command\n");
        return;
    }

    numPlayerToAccept = morpion_existPlayer(sNamePlayer, &(s->games));
    if (numPlayerToAccept == -1){
        socket_print(user, "BAD Wrongly formatted NO (player name) command\n");
        return;
    }

#if 0
    /* Let's see if he's trying to cheat by voting again */
    if (morpion_hasAlreadyVotedforGame(user, numPartie, numPlayerToAccept)){
        socket_print(user, "BAD You have already voted for this game\n");
        return;
    }
#endif
    
    NOTICE("User %d has voted no for the player %d", user, numPlayerToAccept);
    
#if 0
    /* We now remove the voting system from the list */
    morpion_removeVote(numPlayerToAccept, numPartie);
#endif
    
    strToSend = (char *)malloc(sizeof(char) * 50);
    sprintf(strToSend, "BAD Player %s is rejected\n", 
            s->games.players[numPlayerToAccept].playerName);
    /* 
    ** Sending to the player has to be done apart, because the 
    ** morpion_noticeToAllPlayers sends only to the players IN
    ** the game.
    */
    socket_print(numPlayerToAccept, strToSend);
    free(strToSend);
}

/* ************************************************************************
** FUNCTION - proto_JOIN
**   .Usage.
**      JOIN <num d'une partie>
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_JOIN(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd, numPartie, retCode;
    char *strToSend, *playerName =  s->games.players[user].playerName;

    if (playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }

    if (!isNumber(args)){
        socket_print(ev->fd, "BAD Wrongly formatted JOIN command\n");
        return;
    }

    numPartie = atoi(args);
    /* On regarde si la partie choisie est une partie existante */
    if ((morpion_existGameNum(numPartie, &(s->games))) == NULL){
        socket_print(user, "BAD Chosen game does not exist\n");
        return;
    }

    /* On regarde si le joueur n'est pas DEJA dans la partie ;-) */
#if 0
    if (morpion_()){
        socket_print(user, "BAD Player already in that game\n");
        return;
    }
#endif

    /* We initialize the voting system */
    retCode = morpion_askVote(user, numPartie, &(s->games));
    PASSERT(retCode == MORPION_OK, "Error in morpion_askVote(%d)", user);

    /* 
    ** Sending a message to all of the current players in the game telling
    ** that a player want to join 
    */
    strToSend = (char *)malloc(sizeof(char) * (20 + strlen(playerName)));
    sprintf(strToSend, "JOIN %d %s\n", numPartie, playerName);
    morpion_noticeToAllPlayers(user, numPartie, BROADCAST_GAME,
                               strToSend, &(s->games));

    free(strToSend);
}

/* ************************************************************************
** FUNCTION - proto_NEW
**   .Usage.
**      NEW <nom_partie> <nb cases horiz> <nb cases vert> <type of game>
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_NEW(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    int user = ev->fd, userId;
    char *sheight, *swidth, *listOfGames, *strToSend, *stype;
    int width, height, type, retCode;
    long numOfGame;

    if (s->games.players[user].playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }
    
    /* We get the name of the game in "args", and width and height in swidth */
    swidth = split2Args(args, ' ');
    if (swidth == NULL){
        socket_print(user, "BAD Wrongly formatted NEW command\n");
        return;
    }

    /* We separate width and height from the string */
    sheight = split2Args(swidth, ' ');
    if (sheight == NULL){
        socket_print(user, "BAD Wrongly formatted NEW command\n");
        return;
    }

    /* We separate width and height from the string */
    stype = split2Args(sheight, ' ');
    if (stype == NULL){
        socket_print(user, "BAD Wrongly formatted NEW command\n");
        return;
    }

    if (!isNumber(swidth)){
        socket_print(user, "BAD You need to enter the width\n");
        return;
    }
    width = atoi(swidth);

    if (!isNumber(sheight)){
        socket_print(user, "BAD You need to enter the height\n");
        return;
    }
    height = atoi(sheight);

    if (!isNumber(stype)){
        socket_print(user, "BAD You need to enter the type of game\n");
        return;
    }
    type = atoi(stype);
    
    if ((width < 5)||(height < 5)){
        socket_print(user, "BAD Minimal size of the grid must be 5x5\n");
        return;
    }
    
    if ((width == 0) || 
        (height == 0) || 
        (width > MAXWIDTH)||
        (height > MAXHEIGHT)){
        strToSend = (char *)malloc(sizeof(char) * 50);
        sprintf(strToSend, "BAD The grid must have a maximal size of %dx%d\n",
                MAXWIDTH, MAXHEIGHT);
        socket_print(user, strToSend);
        free(strToSend);
        return;
    }
    
    secur_cleanString(args);
    /* We get, in return, the game number Id in numOfGame */
    retCode = morpion_newGame(width, height, args, &numOfGame, type,
                              &(s->games));

    if (retCode != MORPION_OK){
         switch(retCode){
             case MORPION_GAMEEXIST : 
                       socket_print(user, "BAD Game already exists\n");
                       return;
                       break;
             case MORPION_UNKNOWGAME :
                       socket_print(user, "BAD Unknown Type of Game\n");
                       return;
                       break;
             case MORPION_GAMEFULL :
                       socket_print(user, "BAD No Game disponible\n");
                       return;
                       break;
             default:
                       break;
         }
#if 0
        if (retCode == MORPION_GAMEEXIST)
            socket_print(user, "BAD Game already exists\n");
        else 
            socket_print(user, "BAD Unknown error while creating a game\n");
        return;
#endif
    }

    NOTICE("User %d created game %s(%d,%d)", user, args, width, height);

    /*
    ** Quand une personne cree une partie, il y est automatiquement
    ** ajoute.
    */
    retCode = morpion_addPlayer(user, numOfGame, &(s->games));
    PASSERT(retCode == MORPION_OK, "Error in morpion_addPlayer(%d)", retCode);

    strToSend = (char *)malloc(sizeof(char) * 50);
    sprintf(strToSend, "OK %ld\n", numOfGame);
    socket_print(user, strToSend);
    free(strToSend);

    /* 
    ** Notification  toutes les personnes connectees, qu'une nouvelle
    ** partie vient d'etre cree.
    */
    listOfGames = morpion_infoGames(&(s->games));

    /* 
    ** Allocation d'un espace pour y stocker la liste des jeux ainsi que
    ** le mot clef
    */
    strToSend = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                               15));
    sprintf(strToSend, "GAMES %s\n", listOfGames);
    morpion_noticeToAllPlayers(user, -1, 
                               BROADCAST_ALLPLAYERS | BROADCAST_PLAYER,
                               strToSend, &(s->games));
    free(strToSend);
    free(listOfGames);

    morpion_getPlayerId(&userId, user, numOfGame, &(s->games));

    strToSend = (char *)malloc(sizeof(char) * 50);
    sprintf(strToSend, "PLAY %ld %d\n", numOfGame, userId);
    morpion_noticeToAllPlayers(user, numOfGame,
                               BROADCAST_GAME | BROADCAST_PLAYER,
                               strToSend, &(s->games));
    free(strToSend);
}

/* ************************************************************************
** FUNCTION - proto_QUIT
**   .Usage.
**      QUIT <idGame>
**   .Input.
**      Nothing
**   .Return.
**      Nothing
** ***********************************************************************/
void proto_QUIT(SockEvent *ev, char *args)
{
    Sockets *s = ev->ptrSockets;
    char *strToSend, *listOfGames, *gridToSend;
    int user = ev->fd, userId, numGame, userInGame, userNextPlayer;
    ListGameItem *dummy;


    if (s->games.players[user].playerName[0] == '\0'){
        socket_print(user, "BAD You have to register first\n");
        return;
    }

    if (!isNumber(args)){
        socket_print(user, "BAD Wrongly formatted QUIT command (nb expected)\n");
        return;
    }

    numGame = atoi(args);

    if(morpion_getPlayerId(&userId, user, numGame, &(s->games)) != MORPION_OK){
         socket_print(user, "BAD Wrong arguments for QUIT command\n");
        return;
    }
        

    strToSend =(char *)malloc(sizeof(char) * 50);
    sprintf(strToSend, "QUIT %d %d\n", numGame, userId);
    morpion_noticeToAllPlayers(user, numGame, 
                               BROADCAST_GAME|BROADCAST_PLAYER,
                               strToSend,
                               &(s->games));
    free(strToSend);
    
    /* On garde les ID en memoire !! */
    userInGame = morpion_playerInGame(numGame, &(s->games));
    userNextPlayer = morpion_nextPlayer(numGame, &(s->games));
    
    morpion_deletePlayerFromGame(&dummy, user, numGame, &(s->games));

    /* 
    ** Send an updated version of the list of Games and infos
    */
    listOfGames = morpion_infoGames(&(s->games));

    /* 
    ** Allocation d'un espace pour y stocker la liste des jeux ainsi que
    ** le mot clef
    */
    strToSend = (char *)malloc(sizeof(char) * (strlen(listOfGames) +
                               15));
    sprintf(strToSend, "GAMES %s\n", listOfGames);
    morpion_noticeToAllPlayers(user, -1, 
                               BROADCAST_ALLPLAYERS | BROADCAST_PLAYER,
                               strToSend, &(s->games));
    free(strToSend);
    free(listOfGames);

    gridToSend = morpion_grid(numGame, &(s->games));
    /* 
    ** Small test to see if the gaem has been deleted, because there was
    ** only one player
    */
    if (gridToSend != NULL){
        strToSend = (char *)malloc(sizeof(char) * (strlen(gridToSend) + 10));
        sprintf(strToSend, "GRID %s\n", gridToSend);
        morpion_noticeToAllPlayers(user, numGame,
                                   BROADCAST_GAME,
                                   strToSend, &(s->games));
        free(strToSend);
        free(gridToSend);

        /*
        ** Si le joueur qui quitte etait le joueur courant (devant jouer
        ** un coup), on demande au joueur suivant de joueur.
        */
        if ((userId == userInGame) && (userInGame != userNextPlayer)){
            strToSend = (char *)malloc(sizeof(char) * 50);
            sprintf(strToSend, "PLAY %d %d\n", numGame, userNextPlayer);
            morpion_getNumSock(userNextPlayer, &user, numGame, &(s->games));
            morpion_noticeToAllPlayers(user, numGame,
                                       BROADCAST_GAME | BROADCAST_PLAYER,
                                       strToSend, &(s->games));
            free(strToSend);
        }
    }
}


