/* -*-linux-c-*-
** $Id: libsecur.c,v 1.2 1998/04/22 23:18:54 enlight Exp enlight $
** $Log: libsecur.c,v $
** Revision 1.2  1998/04/22 23:18:54  enlight
** Ajout de la fonction secur_CleanString
**
** Revision 1.1  1998/04/22 23:09:56  enlight
** Initial revision
**
*/

#include <stdio.h>
#include <string.h>
#include "../config.h"
#include "servMorp.h"
#include "libsecur.h"

static char *rcsid="@(#) $Id: libsecur.c,v 1.2 1998/04/22 23:18:54 enlight Exp enlight $";

extern char **environ;


/* 
** Function: secur_nettoieEnv
**       In: nothing
**   Return: nothing
** Comments: This function completely removes the IFS and BASH_ENV variables.
*/
void secur_nettoieEnv(void)
{
    char **envp = environ;
    char *deplace, **cur;

    for (cur = envp; *cur; cur++){
        if ((strncmp(*cur, "IFS=", strlen("IFS=")) == 0) ||
            (strncmp(*cur, "BASH_ENV=", strlen("BASH_ENV")) == 0)) {
            
            for (deplace = *cur; *deplace; deplace++)
                *deplace = *(deplace + 1);
            cur--;
        }
    }
}

/* 
** Function: secur_cleanString
**       In: The string to sanitize
**   Return: error code
** Comments: This function removes unwanted caracters from the input string.
*/
void secur_cleanString(char *str)
{
    char *ptr;
    static char ok_chars[] = " abcdefghijklmnopqrstuvwxyz\
ABCDEFGHIJKLMNOPQRSTUVWXYZ{}\
1234567890_-.@";

    for (ptr = str; *(ptr += strspn(ptr, ok_chars)); /* */)
        *ptr = '_';
}
