#include <stdio.h>
#include <stdlib.h>
#include "servMorp.h"
#include "libconnex.h"

#undef DEBUG

#define MAXDATA 512
#define MESSAGETEST2 "DEBUG REFLECT Linux rules the World !!"

enum {
    OPNone,
    OPNew,
    OPSleep,
    OPNick,
    OPImg,
    OPJoin,
    OPHit,
    OPUpdate_hit,
    OPGames
} TypeOpCode;

int nbArgs[50] = {0, /* OpNone */
		  1, /* OpNew */
		  1, /* OpSleep */
		  1, /* OpNick */
		  1, /* OpImg */
		  1, /* OpJoin */
		  3, /* OpHit */
		  4, /* OpUpdate_hit */
		  0, /* OpGames */
};


void usage(void)
{
    fprintf(stderr, "Usage: client <server_address> <port_number>\n\n");
    exit(1);
}

int main(int argc, char *argv[])
{
    int i, sockfd, nbBytes, numPort, ok = 0;
    char buf[MAXDATA], *ptr;
    char name[50];
    struct sockaddr_in theirAddr;
    struct hostent *he;
    struct in_addr ip;

    srand((time(NULL)|1) * getpid());

    if (argc != 3)
	usage();

    /* Testing the args */
    numPort = atoi(argv[2]);
    if (numPort == 0){
	fprintf(stderr, "Port number invalid(%s)\n", argv[2]);
	usage();
    }

#ifdef DEBUG
    printf("Connecting on %s:%s ", argv[1], argv[2]);
#endif

    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1){
	perror("socket");
	exit(1);
    }

    /* Getting the host addr (and testing if in X.X.X.X format by the way) */
    if (!inet_aton(argv[1], &ip)){
	/* inet_aton failed, let's assume it is word.word.net now */
	if ((he = gethostbyname(argv[1])) == NULL){
	    herror("gethostbyname");
	    exit(1);
	}
	memcpy(&ip, he->h_addr_list[0], sizeof(struct in_addr));
    }

    theirAddr.sin_family = AF_INET;
    theirAddr.sin_port = htons(numPort);
    /*    theirAddr.sin_addr.s_addr = inet_addr(argv[1]); */
    theirAddr.sin_addr.s_addr = ip.s_addr;
    bzero(&(theirAddr.sin_zero), 8);

    /* No need to call bind(), as connect calls it automatically */
    if (connect(sockfd, (struct sockaddr *)&theirAddr,
		sizeof(struct sockaddr)) == -1){
	perror("connect");
	exit(1);
    }


    /* We get the Welcome message */
    if ((nbBytes = recv(sockfd, buf, MAXDATA, 0)) == -1){
	perror("recv");
	exit(1);
    }

    buf[nbBytes] = '\0';

#ifdef DEBUG
    printf("\n");
    printf("%s", buf);
#endif

    sleep(1 + (10.0 * rand() / (RAND_MAX + 1.0)));

    /* TEST ONE */
    /* First we register on the server */
    strcpy(name, "NICK    ");
    for (i = 5; i < (5 + 8); i++)
    	name[i] = (20.0 * rand() / RAND_MAX ) + 'a';

    name[5 + 8]= '\0';
    
    if (send(sockfd, name, strlen(name), 0)  == -1){
	perror("send");
	exit(1);
    }

    /* We should receive a OK message */
    if ((nbBytes = recv(sockfd, buf, MAXDATA, 0)) == -1){
	perror("recv");
	exit(1);
    }

    if ((buf[0] == 'O') && (buf[1]=='K'))
	    ok++;

    /* TEST TWO */
    if (send(sockfd, MESSAGETEST2, strlen(MESSAGETEST2), 0)  == -1){
	perror("send");
	exit(1);
    }

    if ((nbBytes = recv(sockfd, buf, MAXDATA, 0)) == -1){
	perror("recv");
	exit(1);
    }

    buf[nbBytes] = '\0';

#ifdef DEBUG
    printf("\n");
    printf("%s", buf);
    printf("\n");
#endif

    if (buf[0] == 'L')
	    ok++;

    if (ok == 2)
	printf("OK");
    else
	printf("ARG PROBLEM !\n");

    sleep(1 + (10.0 * rand() / (RAND_MAX + 1.0)));

    close(sockfd);
	
    return 0;
}
